# Design documents

This directory contains ooni/probe-cli design documents. We generally
use issues as short design documents, but some more-complex discussions
require proper design documents. We started collecting existing design
documents into this repository on 2022-06-13, to provide additional
clarity regarding our more-complex choices.

Implementation aspects _may_ change freely over time and there's no need
to rush back and update the related design document. We want to keep a
design document around to document the _why_ of specific choices.
Most design documents are, therefore, informational and historic by
nature, given that we do not aim to continuously update them.

Rather than radically revamp a design document in case of radical direction
changes, it is advisable to create a new design document referencing the
previous design document and explaining what changed.
